Index: src/hugo/graph_wrapper.h
===================================================================
--- src/hugo/graph_wrapper.h	(revision 739)
+++ src/hugo/graph_wrapper.h	(revision 774)
@@ -13,5 +13,5 @@
 #include <hugo/invalid.h>
 #include <hugo/maps.h>
-//#include <iter_map.h>
+#include <iostream>
 
 namespace hugo {
@@ -97,68 +97,95 @@
 
     GraphWrapper(Graph& _graph) : graph(&_graph) { }
+    GraphWrapper(const GraphWrapper<Graph>& gw) : graph(gw.graph) { }
 //     Graph& getGraph() const { return *graph; }
  
-//    typedef typename Graph::Node Node;
-    class Node : public Graph::Node {
+    typedef typename Graph::Node Node;
+//     class Node : public Graph::Node {
+//       friend class GraphWrapper<Graph>;
+//     public:
+//       Node() { }
+//       Node(const typename Graph::Node& _n) : Graph::Node(_n) { }
+//       // /// \bug construction throughrthr multiple levels should be 
+//       // /// handled better
+//       // Node(const typename ParentGraph::ParentGraph::Node& _n) : 
+//       // Graph::Node(_n) { }
+//       Node(const Invalid& i) : Graph::Node(i) { }
+//     };
+    class NodeIt : public Node { 
+      const GraphWrapper<Graph>* gw;
       friend class GraphWrapper<Graph>;
-    public:
-      Node() { }
-      Node(const typename Graph::Node& _n) : Graph::Node(_n) { }
-      // /// \bug construction throughrthr multiple levels should be 
-      // /// handled better
-      // Node(const typename ParentGraph::ParentGraph::Node& _n) : 
-      // Graph::Node(_n) { }
-      Node(const Invalid& i) : Graph::Node(i) { }
-    };
-    class NodeIt { 
-      friend class GraphWrapper<Graph>;
-      typename Graph::NodeIt n;
      public:
       NodeIt() { }
-      NodeIt(const typename Graph::NodeIt& _n) : n(_n) { }
-      NodeIt(const Invalid& i) : n(i) { }
-      NodeIt(const GraphWrapper<Graph>& _G) : n(*(_G.graph)) { }
-      operator Node() const { return Node(typename Graph::Node(n)); }
-    };
-//    typedef typename Graph::Edge Edge;
-    class Edge : public Graph::Edge {
+      //      NodeIt(const NodeIt& n) : Node(n), gw(n.gw) { }
+      NodeIt(Invalid i) : Node(i) { }
+      NodeIt(const GraphWrapper<Graph>& _gw) : 
+	Node(typename Graph::NodeIt(*(_gw.graph))), gw(&_gw) { }
+      NodeIt(const GraphWrapper<Graph>& _gw, const Node& n) : 
+	Node(n), gw(&_gw) { }
+      NodeIt& operator++() { 
+	*(static_cast<Node*>(this))=
+	  ++(typename Graph::NodeIt(*(gw->graph), *this));
+	return *this; 
+      }
+    };
+    typedef typename Graph::Edge Edge;
+//     class Edge : public Graph::Edge {
+//       friend class GraphWrapper<Graph>;
+//     public:
+//       Edge() { }
+//       Edge(const typename Graph::Edge& _e) : Graph::Edge(_e) { }
+//       Edge(const Invalid& i) : Graph::Edge(i) { }
+//     };
+    class OutEdgeIt : public Edge { 
+      const GraphWrapper<Graph>* gw;
       friend class GraphWrapper<Graph>;
-    public:
-      Edge() { }
-      Edge(const typename Graph::Edge& _e) : Graph::Edge(_e) { }
-      Edge(const Invalid& i) : Graph::Edge(i) { }
-    };
-    class OutEdgeIt { 
+     public:
+      OutEdgeIt() { }
+      //OutEdgeIt(const OutEdgeIt& e) : Edge(e), gw(e.gw) { }
+      OutEdgeIt(Invalid i) : Edge(i) { }
+      OutEdgeIt(const GraphWrapper<Graph>& _gw, const Node& n) : 
+	Edge(typename Graph::OutEdgeIt(*(_gw.graph), n)), gw(&_gw) { }
+      OutEdgeIt(const GraphWrapper<Graph>& _gw, const Edge& e) : 
+	Edge(e), gw(&_gw) { }
+      OutEdgeIt& operator++() { 
+	*(static_cast<Edge*>(this))=
+	  ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
+	return *this; 
+      }
+    };
+    class InEdgeIt : public Edge { 
+      const GraphWrapper<Graph>* gw;
       friend class GraphWrapper<Graph>;
-      typename Graph::OutEdgeIt e;
-    public:
-      OutEdgeIt() { }
-      OutEdgeIt(const typename Graph::OutEdgeIt& _e) : e(_e) { }
-      OutEdgeIt(const Invalid& i) : e(i) { }
-      OutEdgeIt(const GraphWrapper<Graph>& _G, const Node& _n) : 
-	e(*(_G.graph), typename Graph::Node(_n)) { }
-      operator Edge() const { return Edge(typename Graph::Edge(e)); }
-    };
-    class InEdgeIt { 
+     public:
+      InEdgeIt() { }
+      //InEdgeIt(const InEdgeIt& e) : Edge(e), gw(e.gw) { }
+      InEdgeIt(Invalid i) : Edge(i) { }
+      InEdgeIt(const GraphWrapper<Graph>& _gw, const Node& n) : 
+	Edge(typename Graph::InEdgeIt(*(_gw.graph), n)), gw(&_gw) { }
+      InEdgeIt(const GraphWrapper<Graph>& _gw, const Edge& e) : 
+	Edge(e), gw(&_gw) { }
+      InEdgeIt& operator++() { 
+	*(static_cast<Edge*>(this))=
+	  ++(typename Graph::InEdgeIt(*(gw->graph), *this));
+	return *this; 
+      }
+    };
+    //typedef typename Graph::SymEdgeIt SymEdgeIt;
+    class EdgeIt : public Edge { 
+      const GraphWrapper<Graph>* gw;
       friend class GraphWrapper<Graph>;
-      typename Graph::InEdgeIt e;
-    public:
-      InEdgeIt() { }
-      InEdgeIt(const typename Graph::InEdgeIt& _e) : e(_e) { }
-      InEdgeIt(const Invalid& i) : e(i) { }
-      InEdgeIt(const GraphWrapper<Graph>& _G, const Node& _n) : 
-	e(*(_G.graph), typename Graph::Node(_n)) { }
-      operator Edge() const { return Edge(typename Graph::Edge(e)); }
-    };
-    //typedef typename Graph::SymEdgeIt SymEdgeIt;
-    class EdgeIt { 
-      friend class GraphWrapper<Graph>;
-      typename Graph::EdgeIt e;
-    public:
+     public:
       EdgeIt() { }
-      EdgeIt(const typename Graph::EdgeIt& _e) : e(_e) { }
-      EdgeIt(const Invalid& i) : e(i) { }
-      EdgeIt(const GraphWrapper<Graph>& _G) : e(*(_G.graph)) { }
-      operator Edge() const { return Edge(typename Graph::Edge(e)); }
+      //EdgeIt(const EdgeIt& e) : Edge(e), gw(e.gw) { }
+      EdgeIt(Invalid i) : Edge(i) { }
+      EdgeIt(const GraphWrapper<Graph>& _gw) : 
+	Edge(typename Graph::EdgeIt(*(_gw.graph))), gw(&_gw) { }
+      EdgeIt(const GraphWrapper<Graph>& _gw, const Edge& e) : 
+	Edge(w), gw(&_gw) { }
+      EdgeIt& operator++() { 
+	*(static_cast<Edge*>(this))=
+	  ++(typename Graph::EdgeIt(*(gw->graph), *this));
+	return *this; 
+      }
     };
    
@@ -176,8 +203,8 @@
     }
 
-    NodeIt& next(NodeIt& i) const { graph->next(i.n); return i; }
-    OutEdgeIt& next(OutEdgeIt& i) const { graph->next(i.e); return i; }
-    InEdgeIt& next(InEdgeIt& i) const { graph->next(i.e); return i; }
-    EdgeIt& next(EdgeIt& i) const { graph->next(i.e); return i; }    
+//     NodeIt& next(NodeIt& i) const { graph->next(i.n); return i; }
+//     OutEdgeIt& next(OutEdgeIt& i) const { graph->next(i.e); return i; }
+//     InEdgeIt& next(InEdgeIt& i) const { graph->next(i.e); return i; }
+//     EdgeIt& next(EdgeIt& i) const { graph->next(i.e); return i; }    
 
     Node tail(const Edge& e) const { 
@@ -186,16 +213,16 @@
       return Node(graph->head(static_cast<typename Graph::Edge>(e))); }
 
-    bool valid(const Node& n) const { 
-      return graph->valid(static_cast<typename Graph::Node>(n)); }
-    bool valid(const Edge& e) const { 
-      return graph->valid(static_cast<typename Graph::Edge>(e)); }
+//     bool valid(const Node& n) const { 
+//       return graph->valid(static_cast<typename Graph::Node>(n)); }
+//     bool valid(const Edge& e) const { 
+//       return graph->valid(static_cast<typename Graph::Edge>(e)); }
 
     int nodeNum() const { return graph->nodeNum(); }
     int edgeNum() const { return graph->edgeNum(); }
   
-    Node aNode(const OutEdgeIt& e) const { return Node(graph->aNode(e.e)); }
-    Node aNode(const InEdgeIt& e) const { return Node(graph->aNode(e.e)); }
-    Node bNode(const OutEdgeIt& e) const { return Node(graph->bNode(e.e)); }
-    Node bNode(const InEdgeIt& e) const { return Node(graph->bNode(e.e)); }
+//     Node aNode(const OutEdgeIt& e) const { return Node(graph->aNode(e.e)); }
+//     Node aNode(const InEdgeIt& e) const { return Node(graph->aNode(e.e)); }
+//     Node bNode(const OutEdgeIt& e) const { return Node(graph->bNode(e.e)); }
+//     Node bNode(const InEdgeIt& e) const { return Node(graph->bNode(e.e)); }
   
     Node addNode() const { return Node(graph->addNode()); }
@@ -219,6 +246,6 @@
       typedef typename Graph::template NodeMap<T> Parent;
     public:
-      NodeMap(const GraphWrapper<Graph>& _G) :  Parent(*(_G.graph)) { }
-      NodeMap(const GraphWrapper<Graph>& _G, T a) : Parent(*(_G.graph), a) { }
+      NodeMap(const GraphWrapper<Graph>& gw) :  Parent(*(gw.graph)) { }
+      NodeMap(const GraphWrapper<Graph>& gw, T a) : Parent(*(gw.graph), a) { }
     };
 
@@ -226,6 +253,6 @@
       typedef typename Graph::template EdgeMap<T> Parent;
     public:
-      EdgeMap(const GraphWrapper<Graph>& _G) : Parent(*(_G.graph)) { }
-      EdgeMap(const GraphWrapper<Graph>& _G, T a) : Parent(*(_G.graph), a) { }
+      EdgeMap(const GraphWrapper<Graph>& gw) : Parent(*(gw.graph)) { }
+      EdgeMap(const GraphWrapper<Graph>& gw, T a) : Parent(*(gw.graph), a) { }
     };
   };
@@ -247,4 +274,5 @@
   public:
     RevGraphWrapper(Graph& _graph) : GraphWrapper<Graph>(_graph) { }  
+    RevGraphWrapper(const RevGraphWrapper<Graph>& gw) : Parent(gw) { }
 
     typedef typename GraphWrapper<Graph>::Node Node;
@@ -257,27 +285,37 @@
     //typedef typename GraphWrapper<Graph>::InEdgeIt OutEdgeIt;
 
-    class OutEdgeIt { 
+    class OutEdgeIt : public Edge { 
+      const RevGraphWrapper<Graph>* gw;
       friend class GraphWrapper<Graph>;
-      friend class RevGraphWrapper<Graph>;
-      typename Graph::InEdgeIt e;
-    public:
+     public:
       OutEdgeIt() { }
-      OutEdgeIt(const typename Graph::InEdgeIt& _e) : e(_e) { }
-      OutEdgeIt(const Invalid& i) : e(i) { }
-      OutEdgeIt(const RevGraphWrapper<Graph>& _G, const Node& _n) : 
-	e(*(_G.graph), typename Graph::Node(_n)) { }
-      operator Edge() const { return Edge(typename Graph::Edge(e)); }
-    };
-    class InEdgeIt { 
+      //OutEdgeIt(const OutEdgeIt& e) : Edge(e), gw(e.gw) { }
+      OutEdgeIt(Invalid i) : Edge(i) { }
+      OutEdgeIt(const RevGraphWrapper<Graph>& _gw, const Node& n) : 
+	Edge(typename Graph::InEdgeIt(*(_gw.graph), n)), gw(&_gw) { }
+      OutEdgeIt(const RevGraphWrapper<Graph>& _gw, const Edge& e) : 
+	Edge(e), gw(&_gw) { }
+      OutEdgeIt& operator++() { 
+	*(static_cast<Edge*>(this))=
+	  ++(typename Graph::InEdgeIt(*(gw->graph), *this));
+	return *this; 
+      }
+    };
+    class InEdgeIt : public Edge { 
+      const RevGraphWrapper<Graph>* gw;
       friend class GraphWrapper<Graph>;
-      friend class RevGraphWrapper<Graph>;
-      typename Graph::OutEdgeIt e;
-    public:
+     public:
       InEdgeIt() { }
-      InEdgeIt(const typename Graph::OutEdgeIt& _e) : e(_e) { }
-      InEdgeIt(const Invalid& i) : e(i) { }
-      InEdgeIt(const RevGraphWrapper<Graph>& _G, const Node& _n) : 
-	e(*(_G.graph), typename Graph::Node(_n)) { }
-      operator Edge() const { return Edge(typename Graph::Edge(e)); }
+      //InEdgeIt(const InEdgeIt& e) : Edge(e), gw(e.gw) { }
+      InEdgeIt(Invalid i) : Edge(i) { }
+      InEdgeIt(const RevGraphWrapper<Graph>& _gw, const Node& n) : 
+	Edge(typename Graph::OutEdgeIt(*(_gw.graph), n)), gw(&_gw) { }
+      InEdgeIt(const RevGraphWrapper<Graph>& _gw, const Edge& e) : 
+	Edge(e), gw(&_gw) { }
+      InEdgeIt& operator++() { 
+	*(static_cast<Edge*>(this))=
+	  ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
+	return *this; 
+      }
     };
 
@@ -290,16 +328,16 @@
     }
 
-    using GraphWrapper<Graph>::next;
-    OutEdgeIt& next(OutEdgeIt& i) const { this->graph->next(i.e); return i; }
-    InEdgeIt& next(InEdgeIt& i) const { this->graph->next(i.e); return i; }
-
-    Node aNode(const OutEdgeIt& e) const { 
-      return Node(this->graph->aNode(e.e)); }
-    Node aNode(const InEdgeIt& e) const { 
-      return Node(this->graph->aNode(e.e)); }
-    Node bNode(const OutEdgeIt& e) const { 
-      return Node(this->graph->bNode(e.e)); }
-    Node bNode(const InEdgeIt& e) const { 
-      return Node(this->graph->bNode(e.e)); }
+//     using GraphWrapper<Graph>::next;
+//     OutEdgeIt& next(OutEdgeIt& i) const { this->graph->next(i.e); return i; }
+//     InEdgeIt& next(InEdgeIt& i) const { this->graph->next(i.e); return i; }
+
+//     Node aNode(const OutEdgeIt& e) const { 
+//       return Node(this->graph->aNode(e.e)); }
+//     Node aNode(const InEdgeIt& e) const { 
+//       return Node(this->graph->aNode(e.e)); }
+//     Node bNode(const OutEdgeIt& e) const { 
+//       return Node(this->graph->bNode(e.e)); }
+//     Node bNode(const InEdgeIt& e) const { 
+//       return Node(this->graph->bNode(e.e)); }
 
     Node tail(const Edge& e) const { 
@@ -309,6 +347,4 @@
 
   };
-
-
 
   /// A graph wrapper for hiding nodes and edges from a graph.
@@ -627,7 +663,4 @@
     typedef GraphWrapper<Graph> Parent; 
   protected:
-    //const CapacityMap* capacity;
-    //FlowMap* flow;
-
     ForwardFilterMap* forward_filter;
     BackwardFilterMap* backward_filter;
@@ -648,4 +681,9 @@
       GraphWrapper<Graph>(_graph), 
       forward_filter(&_forward_filter), backward_filter(&_backward_filter) { }
+    SubBidirGraphWrapper(const SubBidirGraphWrapper<Graph, 
+			 ForwardFilterMap, BackwardFilterMap>& gw) : 
+      Parent(gw), 
+      forward_filter(gw.forward_filter), 
+      backward_filter(gw.backward_filter) { }
 
     class Edge; 
@@ -658,6 +696,7 @@
 
     typedef typename GraphWrapper<Graph>::Node Node;
-    typedef typename GraphWrapper<Graph>::NodeIt NodeIt;
-
+    //typedef typename GraphWrapper<Graph>::NodeIt NodeIt;
+
+    typedef typename Graph::Edge GraphEdge;
     class Edge : public Graph::Edge {
       friend class SubBidirGraphWrapper<Graph, 
@@ -672,114 +711,194 @@
       Edge() { }
       ///\bug =false kell-e? zsoltnak kell az addEdge miatt
-      Edge(const typename Graph::Edge& _e, bool _backward=false) : 
-	Graph::Edge(_e), backward(_backward) { }
-      Edge(const Invalid& i) : Graph::Edge(i), backward(true) { }
+      Edge(const typename Graph::Edge& e, bool _backward/*=false*/) : 
+	Graph::Edge(e), backward(_backward) { }
+      Edge(Invalid i) : Graph::Edge(i), backward(true) { }
 //the unique invalid iterator
-      friend bool operator==(const Edge& u, const Edge& v) { 
-	return (v.backward==u.backward && 
-		static_cast<typename Graph::Edge>(u)==
+//       friend bool operator==(const Edge& u, const Edge& v) { 
+// 	return (u.backward==v.backward && 
+// 		static_cast<typename Graph::Edge>(u)==
+// 		static_cast<typename Graph::Edge>(v));
+//       } 
+//       friend bool operator!=(const Edge& u, const Edge& v) { 
+// 	return (u.backward!=v.backward || 
+// 		static_cast<typename Graph::Edge>(u)!=
+// 		static_cast<typename Graph::Edge>(v));
+//       }
+      bool operator==(const Edge& v) const { 
+	return (this->backward==v.backward && 
+		static_cast<typename Graph::Edge>(*this)==
 		static_cast<typename Graph::Edge>(v));
       } 
-      friend bool operator!=(const Edge& u, const Edge& v) { 
-	return (v.backward!=u.backward || 
-		static_cast<typename Graph::Edge>(u)!=
+      bool operator!=(const Edge& v) const { 
+	return (this->backward!=v.backward || 
+		static_cast<typename Graph::Edge>(*this)!=
 		static_cast<typename Graph::Edge>(v));
-      } 
-    };
-
-    class OutEdgeIt {
+      }
+    };
+
+    class OutEdgeIt : public Edge {
       friend class SubBidirGraphWrapper<Graph, 
 					ForwardFilterMap, BackwardFilterMap>;
     protected:
-      typename Graph::OutEdgeIt out;
-      typename Graph::InEdgeIt in;
-      bool backward;
+      const SubBidirGraphWrapper<Graph, 
+				 ForwardFilterMap, BackwardFilterMap>* gw;
     public:
       OutEdgeIt() { }
-      //FIXME
-//      OutEdgeIt(const Edge& e) : Edge(e) { }
-      OutEdgeIt(const Invalid& i) : out(i), in(i), backward(true) { }
+      OutEdgeIt(Invalid i) : Edge(i) { }
 //the unique invalid iterator
       OutEdgeIt(const SubBidirGraphWrapper<Graph, 
-		ForwardFilterMap, BackwardFilterMap>& _G, Node v) { 
-	backward=false;
-	_G.graph->first(out, v);
-	while(_G.graph->valid(out) && !(*_G.forward_filter)[*this]) { _G.graph->next(out); }
-	if (!_G.graph->valid(out)) {
-	  backward=true;
-	  _G.graph->first(in, v);
-	  while(_G.graph->valid(in) && !(*_G.backward_filter)[*this]) { _G.graph->next(in); }
+		ForwardFilterMap, BackwardFilterMap>& _gw, const Node& n) : 
+	Edge(typename Graph::OutEdgeIt(*(_gw.graph), n), false), gw(&_gw) { 
+	while (*static_cast<GraphEdge*>(this)!=INVALID && 
+	       !(*(gw->forward_filter))[*this]) 
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
+	if (*static_cast<GraphEdge*>(this)==INVALID) 
+	  *static_cast<Edge*>(this)=
+	    Edge(typename Graph::InEdgeIt(*(_gw.graph), n), true);
+	while (*static_cast<GraphEdge*>(this)!=INVALID && 
+	       !(*(gw->backward_filter))[*this]) 
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::InEdgeIt(*(gw->graph), *this));
+      }
+      OutEdgeIt(const SubBidirGraphWrapper<Graph, 
+		ForwardFilterMap, BackwardFilterMap>& _gw, const Edge& e) : 
+	Edge(e), gw(&_gw) { }
+      OutEdgeIt& operator++() { 
+	if (!this->backward) {
+	  Node n=gw->tail(*this);
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->forward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
+	  if (*static_cast<GraphEdge*>(this)==INVALID) 
+	    *static_cast<Edge*>(this)=
+	      Edge(typename Graph::InEdgeIt(*(gw->graph), n), true);
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->backward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::InEdgeIt(*(gw->graph), *this));
+	} else {
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::InEdgeIt(*(gw->graph), *this));
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->backward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::InEdgeIt(*(gw->graph), *this));
 	}
-      }
-      operator Edge() const { 
-//	Edge e;
-//	e.forward=this->forward;
-//	if (this->forward) e=out; else e=in;
-//	return e;
-	if (this->backward) 
-	  return Edge(in, this->backward); 
-	else 
-	  return Edge(out, this->backward);
-      }
-    };
-
-    class InEdgeIt {
+	return *this;
+      }
+    };
+
+    class InEdgeIt : public Edge {
       friend class SubBidirGraphWrapper<Graph, 
 					ForwardFilterMap, BackwardFilterMap>;
     protected:
-      typename Graph::OutEdgeIt out;
-      typename Graph::InEdgeIt in;
-      bool backward;
+      const SubBidirGraphWrapper<Graph, 
+				 ForwardFilterMap, BackwardFilterMap>* gw;
     public:
       InEdgeIt() { }
-      //FIXME
-//      OutEdgeIt(const Edge& e) : Edge(e) { }
-      InEdgeIt(const Invalid& i) : out(i), in(i), backward(true) { }
+      InEdgeIt(Invalid i) : Edge(i) { }
 //the unique invalid iterator
       InEdgeIt(const SubBidirGraphWrapper<Graph, 
-	       ForwardFilterMap, BackwardFilterMap>& _G, Node v) { 
-	backward=false;
-	_G.graph->first(in, v);
-	while(_G.graph->valid(in) && !(*_G.forward_filter)[*this]) { _G.graph->next(in); }
-	if (!_G.graph->valid(in)) {
-	  backward=true;
-	  _G.graph->first(out, v);
-	  while(_G.graph->valid(out) && !(*_G.backward_filter)[*this]) { _G.graph->next(out); }
+	       ForwardFilterMap, BackwardFilterMap>& _gw, const Node& n) : 
+	Edge(typename Graph::InEdgeIt(*(_gw.graph), n), false), gw(&_gw) { 
+	while (*static_cast<GraphEdge*>(this)!=INVALID && 
+	       !(*(gw->forward_filter))[*this]) 
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::InEdgeIt(*(gw->graph), *this));
+	if (*static_cast<GraphEdge*>(this)==INVALID) 
+	  *static_cast<Edge*>(this)=
+	    Edge(typename Graph::OutEdgeIt(*(_gw.graph), n), true);
+	while (*static_cast<GraphEdge*>(this)!=INVALID && 
+	       !(*(gw->backward_filter))[*this]) 
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
+      }
+      InEdgeIt(const SubBidirGraphWrapper<Graph, 
+	       ForwardFilterMap, BackwardFilterMap>& _gw, const Edge& e) : 
+	Edge(e), gw(&_gw) { }
+      InEdgeIt& operator++() { 
+	if (!this->backward) {
+	  Node n=gw->head(*this);
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::InEdgeIt(*(gw->graph), *this));
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->forward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::InEdgeIt(*(gw->graph), *this));
+	  if (*static_cast<GraphEdge*>(this)==INVALID) 
+	    *static_cast<Edge*>(this)=
+	      Edge(typename Graph::OutEdgeIt(*(gw->graph), n), true);
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->backward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
+	} else {
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->backward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::OutEdgeIt(*(gw->graph), *this));
 	}
-      }
-      operator Edge() const { 
-//	Edge e;
-//	e.forward=this->forward;
-//	if (this->forward) e=out; else e=in;
-//	return e;
-	if (this->backward) 
-	  return Edge(out, this->backward); 
-	else 
-	  return Edge(in, this->backward);
-      }
-    };
-
-    class EdgeIt {
+	return *this;
+      }
+    };
+
+    class EdgeIt : public Edge {
       friend class SubBidirGraphWrapper<Graph, 
 					ForwardFilterMap, BackwardFilterMap>;
     protected:
-      typename Graph::EdgeIt e;
-      bool backward;
+      const SubBidirGraphWrapper<Graph, 
+				 ForwardFilterMap, BackwardFilterMap>* gw;
     public:
       EdgeIt() { }
-      EdgeIt(const Invalid& i) : e(i), backward(true) { }
+      EdgeIt(Invalid i) : Edge(i) { }
+//the unique invalid iterator
       EdgeIt(const SubBidirGraphWrapper<Graph, 
-	     ForwardFilterMap, BackwardFilterMap>& _G) { 
-	backward=false;
-	_G.graph->first(e);
-	while (_G.graph->valid(e) && !(*_G.forward_filter)[*this]) _G.graph->next(e);
-	if (!_G.graph->valid(e)) {
-	  backward=true;
-	  _G.graph->first(e);
-	  while (_G.graph->valid(e) && !(*_G.backward_filter)[*this]) _G.graph->next(e);
+		ForwardFilterMap, BackwardFilterMap>& _gw) : 
+	Edge(typename Graph::EdgeIt(*(_gw.graph)), false), gw(&_gw) { 
+	while (*static_cast<GraphEdge*>(this)!=INVALID && 
+	       !(*(gw->forward_filter))[*this]) 
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::EdgeIt(*(gw->graph), *this));
+	if (*static_cast<GraphEdge*>(this)==INVALID) 
+	  *static_cast<Edge*>(this)=
+	    Edge(typename Graph::EdgeIt(*(_gw.graph)), true);
+	while (*static_cast<GraphEdge*>(this)!=INVALID && 
+	       !(*(gw->backward_filter))[*this]) 
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::EdgeIt(*(gw->graph), *this));
+      }
+      EdgeIt(const SubBidirGraphWrapper<Graph, 
+	     ForwardFilterMap, BackwardFilterMap>& _gw, const Edge& e) : 
+	Edge(e), gw(&_gw) { }
+      EdgeIt& operator++() { 
+	if (!this->backward) {
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::EdgeIt(*(gw->graph), *this));
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->forward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::EdgeIt(*(gw->graph), *this));
+	  if (*static_cast<GraphEdge*>(this)==INVALID) 
+	    *static_cast<Edge*>(this)=
+	      Edge(typename Graph::EdgeIt(*(gw->graph)), true);
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->backward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::EdgeIt(*(gw->graph), *this));
+	} else {
+	  *(static_cast<GraphEdge*>(this))=
+	    ++(typename Graph::EdgeIt(*(gw->graph), *this));
+	  while (*static_cast<GraphEdge*>(this)!=INVALID && 
+		 !(*(gw->backward_filter))[*this]) 
+	    *(static_cast<GraphEdge*>(this))=
+	      ++(typename Graph::EdgeIt(*(gw->graph), *this));
 	}
-      }
-      operator Edge() const { 
-	return Edge(e, this->backward);
+	return *this;
       }
     };
@@ -800,63 +919,63 @@
     }
   
-    using GraphWrapper<Graph>::next;
-//    NodeIt& next(NodeIt& n) const { GraphWrapper<Graph>::next(n); return n; }
-    OutEdgeIt& next(OutEdgeIt& e) const { 
-      if (!e.backward) {
-	Node v=this->graph->aNode(e.out);
-	this->graph->next(e.out);
-	while(this->graph->valid(e.out) && !(*forward_filter)[e]) { 
-	  this->graph->next(e.out); }
-	if (!this->graph->valid(e.out)) {
-	  e.backward=true;
-	  this->graph->first(e.in, v); 
-	  while(this->graph->valid(e.in) && !(*backward_filter)[e]) { 
-	    this->graph->next(e.in); }
-	}
-      } else {
-	this->graph->next(e.in);
-	while(this->graph->valid(e.in) && !(*backward_filter)[e]) { 
-	  this->graph->next(e.in); } 
-      }
-      return e;
-    }
-//     FIXME Not tested
-    InEdgeIt& next(InEdgeIt& e) const { 
-      if (!e.backward) {
-	Node v=this->graph->aNode(e.in);
-	this->graph->next(e.in);
-	while(this->graph->valid(e.in) && !(*forward_filter)[e]) { 
-	  this->graph->next(e.in); }
-	if (!this->graph->valid(e.in)) {
-	  e.backward=true;
-	  this->graph->first(e.out, v); 
-	  while(this->graph->valid(e.out) && !(*backward_filter)[e]) { 
-	    this->graph->next(e.out); }
-	}
-      } else {
-	this->graph->next(e.out);
-	while(this->graph->valid(e.out) && !(*backward_filter)[e]) { 
-	  this->graph->next(e.out); } 
-      }
-      return e;
-    }
-    EdgeIt& next(EdgeIt& e) const {
-      if (!e.backward) {
-	this->graph->next(e.e);
-	while(this->graph->valid(e.e) && !(*forward_filter)[e]) { 
-	  this->graph->next(e.e); }
-	if (!this->graph->valid(e.e)) {
-	  e.backward=true;
-	  this->graph->first(e.e); 
-	  while(this->graph->valid(e.e) && !(*backward_filter)[e]) { 
-	    this->graph->next(e.e); }
-	}
-      } else {
-	this->graph->next(e.e);
-	while(this->graph->valid(e.e) && !(*backward_filter)[e]) { 
-	  this->graph->next(e.e); } 
-      }
-      return e;
-    }
+//     using GraphWrapper<Graph>::next;
+// //    NodeIt& next(NodeIt& n) const { GraphWrapper<Graph>::next(n); return n; }
+//     OutEdgeIt& next(OutEdgeIt& e) const { 
+//       if (!e.backward) {
+// 	Node v=this->graph->aNode(e.out);
+// 	this->graph->next(e.out);
+// 	while(this->graph->valid(e.out) && !(*forward_filter)[e]) { 
+// 	  this->graph->next(e.out); }
+// 	if (!this->graph->valid(e.out)) {
+// 	  e.backward=true;
+// 	  this->graph->first(e.in, v); 
+// 	  while(this->graph->valid(e.in) && !(*backward_filter)[e]) { 
+// 	    this->graph->next(e.in); }
+// 	}
+//       } else {
+// 	this->graph->next(e.in);
+// 	while(this->graph->valid(e.in) && !(*backward_filter)[e]) { 
+// 	  this->graph->next(e.in); } 
+//       }
+//       return e;
+//     }
+// //     FIXME Not tested
+//     InEdgeIt& next(InEdgeIt& e) const { 
+//       if (!e.backward) {
+// 	Node v=this->graph->aNode(e.in);
+// 	this->graph->next(e.in);
+// 	while(this->graph->valid(e.in) && !(*forward_filter)[e]) { 
+// 	  this->graph->next(e.in); }
+// 	if (!this->graph->valid(e.in)) {
+// 	  e.backward=true;
+// 	  this->graph->first(e.out, v); 
+// 	  while(this->graph->valid(e.out) && !(*backward_filter)[e]) { 
+// 	    this->graph->next(e.out); }
+// 	}
+//       } else {
+// 	this->graph->next(e.out);
+// 	while(this->graph->valid(e.out) && !(*backward_filter)[e]) { 
+// 	  this->graph->next(e.out); } 
+//       }
+//       return e;
+//     }
+//     EdgeIt& next(EdgeIt& e) const {
+//       if (!e.backward) {
+// 	this->graph->next(e.e);
+// 	while(this->graph->valid(e.e) && !(*forward_filter)[e]) { 
+// 	  this->graph->next(e.e); }
+// 	if (!this->graph->valid(e.e)) {
+// 	  e.backward=true;
+// 	  this->graph->first(e.e); 
+// 	  while(this->graph->valid(e.e) && !(*backward_filter)[e]) { 
+// 	    this->graph->next(e.e); }
+// 	}
+//       } else {
+// 	this->graph->next(e.e);
+// 	while(this->graph->valid(e.e) && !(*backward_filter)[e]) { 
+// 	  this->graph->next(e.e); } 
+//       }
+//       return e;
+//     }
 
     Node tail(Edge e) const { 
@@ -865,17 +984,17 @@
       return ((!e.backward) ? this->graph->head(e) : this->graph->tail(e)); }
 
-    Node aNode(OutEdgeIt e) const { 
-      return ((!e.backward) ? this->graph->aNode(e.out) : 
-	      this->graph->aNode(e.in)); }
-    Node bNode(OutEdgeIt e) const { 
-      return ((!e.backward) ? this->graph->bNode(e.out) : 
-	      this->graph->bNode(e.in)); }
-
-    Node aNode(InEdgeIt e) const { 
-      return ((!e.backward) ? this->graph->aNode(e.in) : 
-	      this->graph->aNode(e.out)); }
-    Node bNode(InEdgeIt e) const { 
-      return ((!e.backward) ? this->graph->bNode(e.in) : 
-	      this->graph->bNode(e.out)); }
+//     Node aNode(OutEdgeIt e) const { 
+//       return ((!e.backward) ? this->graph->aNode(e.out) : 
+// 	      this->graph->aNode(e.in)); }
+//     Node bNode(OutEdgeIt e) const { 
+//       return ((!e.backward) ? this->graph->bNode(e.out) : 
+// 	      this->graph->bNode(e.in)); }
+
+//     Node aNode(InEdgeIt e) const { 
+//       return ((!e.backward) ? this->graph->aNode(e.in) : 
+// 	      this->graph->aNode(e.out)); }
+//     Node bNode(InEdgeIt e) const { 
+//       return ((!e.backward) ? this->graph->bNode(e.in) : 
+// 	      this->graph->bNode(e.out)); }
 
     /// Gives back the opposite edge.
@@ -894,9 +1013,9 @@
 //    int id(Node v) const { return graph->id(v); }
 
-    bool valid(Node n) const { return GraphWrapper<Graph>::valid(n); }
-    bool valid(Edge e) const { 
-      return this->graph->valid(e);
-	//return e.forward ? graph->valid(e.out) : graph->valid(e.in); 
-    }
+//     bool valid(Node n) const { return GraphWrapper<Graph>::valid(n); }
+//     bool valid(Edge e) const { 
+//       return this->graph->valid(e);
+// 	//return e.forward ? graph->valid(e.out) : graph->valid(e.in); 
+//     }
 
     bool forward(const Edge& e) const { return !e.backward; }
@@ -940,9 +1059,9 @@
       typedef Edge KeyType;
       EdgeMap(const SubBidirGraphWrapper<Graph, 
-	      ForwardFilterMap, BackwardFilterMap>& _G) : 
-	forward_map(*(_G.graph)), backward_map(*(_G.graph)) { }
+	      ForwardFilterMap, BackwardFilterMap>& g) : 
+	forward_map(*(g.graph)), backward_map(*(g.graph)) { }
       EdgeMap(const SubBidirGraphWrapper<Graph, 
-	      ForwardFilterMap, BackwardFilterMap>& _G, T a) : 
-	forward_map(*(_G.graph), a), backward_map(*(_G.graph), a) { }
+	      ForwardFilterMap, BackwardFilterMap>& g, T a) : 
+	forward_map(*(g.graph), a), backward_map(*(g.graph), a) { }
       void set(Edge e, T a) { 
 	if (!e.backward) 
